$(document).ready(function() {

	function getParameterByName(name) {
		name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
		var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
			results = regex.exec(location.search);
		return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
	}

	
	$('#set_tax_rule').change(function(){
	
	//is element before or after
	function isAfter(elA, elB) {
		return ($('*').index($(elA).last()) > $('*').index($(elB).first()));
	}	
	
		var tax_rule = $('#set_tax_rule').val();

		var invoice = [];
		var inputs = document.getElementsByTagName("input");
		for(var i = 0; i < inputs.length; i++) {

			var thisInputName = inputs[i].getAttribute("name");
			
			if(thisInputName !== null){
			
				if(getParameterByName('action') == "add"){
					var act = "inv_add";
				}else{
					var act = "inv[";
				}
			
				if(thisInputName.indexOf(act ) >= 0) {
					
					var rowNumber = parseInt(thisInputName.match(/\d+/)[0]);

					// Reset the var
					invoiceItem = {};		
					invoiceItem[rowNumber] = {};							
					
					// Limit to only the fields we need
					if(thisInputName.indexOf("[product_id]") >= 0){
						invoiceItem[rowNumber]['id'] = inputs[i].value;
					}

					if(thisInputName.indexOf("[line_price]") >= 0){
						invoiceItem[rowNumber]['total_price_each'] = inputs[i].value;
					}
					
					if(thisInputName.indexOf("[product_quantity]") >= 0){
						invoiceItem[rowNumber]['quantity'] = inputs[i].value;
					}

					if(thisInputName.indexOf("[price]") >= 0){
						invoiceItem[rowNumber]['price'] = inputs[i].value;
					}

					invoice.push(invoiceItem);	
					
				}
			}
		}
		

		var discount_type = $('#discount_type').val();
		var discount_value = parseFloat($('#discount').val());
		var shipping_value = parseFloat($('#shipping').val());
		var subtotal = parseFloat($('#subtotal').val());
		
		if(isNaN(shipping_value) === true ){
			shipping_value = 0;
		}
		
		if(isNaN(discount_value) === true ){
			discount_value = 0;
		}		

		var fields = '_g=xml&type=autoTax&function=autoTax&invSubtotal='+subtotal+'&taxCountry='+tax_rule+'&invoiceItems='+JSON.stringify(invoice)+'&shippingValue='+shipping_value;
		
		// math
		if(discount_value > 0){
			if(discount_type == "p"){
				var total_discount = parseFloat((subtotal / 100) * discount_value).toFixed(2) ;
			}else{
				var total_discount = parseFloat(discount_value).toFixed(2);	
			}
			
			fields = fields+'&totalDiscount='+total_discount;
		}
		
		
		
		$.ajax({
		  url: "./" + $("#val_admin_file").text(),
		  type: 'GET',
		  data: fields,
		  success: function(data) {
			var tax = jQuery.parseJSON(data);
			var $startElement = $('#set_tax_rule');
			var $inputs = $('input[type=text]');
			//search inputs for one that comes after starting element
			for (var i = 0; i < $inputs.length; i++) {
				if (isAfter($inputs[i], $startElement)) {
					var nextInput = $inputs[i];
					$(nextInput).val(tax.total_tax)
					break;
				}
			}				
		  },
		  error: function(e) {
			//called when there is an error
			console.log(e.message);
		  }
		});		



		// Sets the next value

		
	});
	
	

	
	
	function ajaxSuggest1(t, e, i) {
	
		// Ajax Call
		var invoice = [];
		var inputs = document.getElementsByTagName("input");
		
		for(var i = 0; i < inputs.length; i++) {

			var thisInputName = inputs[i].getAttribute("name");
			
			if(thisInputName !== null){
			
				if(getParameterByName('action') == "add"){
					var act = "inv_add";
				}else{
					var act = "inv[";
				}			
			
				if(thisInputName.indexOf(act) >= 0) {
					var rowNumber = parseInt(thisInputName.match(/\d+/)[0]);
				
					// Reset the var
					invoiceItem = {};		
					invoiceItem[rowNumber] = {};		
					
					
					// Limit to only the fields we need
					if(thisInputName.indexOf("[product_id]") >= 0){
						invoiceItem[rowNumber]['id'] = inputs[i].value;
					}

					if(thisInputName.indexOf("[line_price]") >= 0){
						invoiceItem[rowNumber]['total_price_each'] = inputs[i].value;
					}
					
					if(thisInputName.indexOf("[product_quantity]") >= 0){
						invoiceItem[rowNumber]['quantity'] = inputs[i].value;
					}

					if(thisInputName.indexOf("[price]") >= 0){
						invoiceItem[rowNumber]['price'] = inputs[i].value;
					}
					
					invoice.push(JSON.stringify(invoiceItem));					
				}		
			}
		}

		// Get the delivery information
		var deliveryPostcode = $('#d_sum_postcode').val();
		var deliveryCounty = $('#d_sum_state').val();
		var deliveryCountry = $('#d_sum_country').val();
		var deliveryTown = $('#d_sum_town').val();
		var deliveryLine2 = $('#d_sum_line2').val();
		var deliveryLine1 = $('#d_sum_line1').val();
		var deliveryCompanyName = $('#d_sum_company_name').val();
		var deliverySurname = $('#d_ajax_last_name').val();
		var deliveryFirstName = $('#d_ajax_first_name').val();
		
		// Setup our delivery address var
		deliveryAddress = {};		
		deliveryAddress[999] = {};
		deliveryAddress[999]['first_name'] = deliveryFirstName;
		deliveryAddress[999]['last_name'] = deliverySurname;
		deliveryAddress[999]['company_name'] = deliveryCompanyName;
		deliveryAddress[999]['line2'] = deliveryLine2;
		deliveryAddress[999]['line1'] = deliveryLine1;
		deliveryAddress[999]['town'] = deliveryTown;
		deliveryAddress[999]['country'] = deliveryCountry;
		deliveryAddress[999]['country_id'] = deliveryCountry;
		deliveryAddress[999]['state'] = deliveryCounty;
		deliveryAddress[999]['state_id'] = deliveryCounty;
		deliveryAddress[999]['postcode'] = deliveryPostcode;
		deliveryAddress[999]['state_abbrev'] = 'ZZZZZ';
		invoice.push(JSON.stringify(deliveryAddress));

		var a = "./" + $("#val_admin_file").text(),
			n = {
				_g: "xml",
				type: i,
				q: t,
				"function": "shippingoptions",
				invoiceItems: invoice
			};
			
		$.get(a, n, function(t) {
			for (var i = [], a = 0; a < t.length; a++)
				i.push({			
					id: t[a].value,
					value: t[a].display,
					info: t[a].info,
					data: t[a].data
			});
			e(i)
		}, "json")
	}
	
	function ajaxSelected1(t, e, i) {
		// This triggers a recalculation
		$('#shipping').trigger("change");
	}

	
	$("#shipping").autocomplete({
		timeout: 5e3,
		ajax_get: ajaxSuggest1,
		callback: ajaxSelected1,
		minchars: 0
	});

	
	$("#showMeShippingOptions").click(function(){
		$("#shipping").focus();
		var e = jQuery.Event("keydown");
		e.keyCode = 50;                     
		$("#shipping").trigger(e);  		
		var e = jQuery.Event("keyup");
		e.keyCode = 50;                     
		$("#shipping").trigger(e);  				
		});
	
})
